#define EJUDGE
#include "testlib.h"

#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <math.h>
#include <string.h>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <sstream>

using namespace std;

int main(int argc, char ** argv)
{
    registerTestlibCmd(argc, argv);
    int N = inf.readInt();
    int K = ouf.readInt();
    int i, j;
    if (K < 1 || K > N * N)
        quit(_wa, "K < 1 or K too big");
    vector < vector < pair <int, int > > > Games(K);
    for (i = 0; i < K; ++i)
    {
        int n = ouf.readInt();
        char c = ouf.readChar();
        for (j = 0; j < n; ++j)
        {
            int a = 0, b = 0;
            while (c == ' ')
                c = ouf.readChar();
            if (!isdigit(c))
                quitf(_pe, "Tour %d, game %d: Digit expected, but '%c' found", i + 1, j + 1, c);
            while (isdigit(c))
            {
                a = a * 10 + c - '0'; 
                c = ouf.readChar();
            }
            if (c != '-')
                quitf(_pe, "Tour %d, game %d: '-' expected, but '%c' found", i + 1, j + 1, c);
            c = ouf.readChar();
            if (!isdigit(c))
                quitf(_pe, "Tour %d, game %d: Digit expected, but '%c' found", i + 1, j + 1, c);
            while (isdigit(c))
            {
                b = b * 10 + c - '0'; 
                c = ouf.readChar();
            }
            Games[i].push_back(make_pair(a, b));
        }
    }
    if (K != N - 1 + N % 2)
    {
        quitf(_wa, "Wrong number of tours, %d expected, %d found",  N - 1 + N % 2, K);
    }
    set < pair <int, int> > Pairs;
    set <int> CurrentTour;
    for (i = 0; i < K; ++i)
    {
        CurrentTour.clear();
        for (j = 0; j < Games[i].size(); ++j)
        {
            int a = Games[i][j].first;
            int b = Games[i][j].second;
            if (a < 1 || a > N)
                quitf(_wa, "Tour %d, game %d: wrong number of command %d", i + 1, j + 1, a);
            if (b < 1 || b > N)
                quitf(_wa, "Tour %d, game %d: wrong number of command %d", i + 1, j + 1, b);
            if (a == b)
                quitf(_wa, "Tour %d, game %d: wrong game %d-%d", i + 1, j + 1, a, b);
            if (a > b)
                swap(a, b);
            if (CurrentTour.count(a))
                quitf(_wa, "Tour %d, game %d: command %d plays two ganes in the tour", i + 1, j + 1, a);
            else
                CurrentTour.insert(a);
            if (CurrentTour.count(b))
                quitf(_wa, "Tour %d, game %d: command %d plays two ganes in the tour", i + 1, j + 1, b);
            else
                CurrentTour.insert(b);
            if (Pairs.count(make_pair(a, b)))
                quitf(_wa, "Tour %d, game %d: commands %d-%d plays the second game in tournament", i + 1, j + 1, a, b);
            else
                Pairs.insert(make_pair(a, b));
        }
    }
    if (Pairs.size() != N * (N - 1) / 2)
        quitf(_wa, "Not all games played, expected %d games, but found %d", N * (N - 1) / 2, Pairs.size());
    else
        quit(_ok, "OK");
    return 0;
}

